/***
   HISTORY
     mloennro - Dec 22, 1994: Created.
     $Log: wowstub.c,v $
 * Revision 1.1  1994/12/28  13:46:35  mloennro
 * Initial revision
 *
***/
static char rcsid[] = "$Header: /home/mloennro/sdk/cwow/RCS/wowstub.c,v 1.1 1994/12/28 13:46:35 mloennro Exp mloennro $";
#include "wowstub.h"
/*#define DEBUG*/

/* Debug: 1=trace calls 2=trace data 3=trace oci */
#ifdef DEBUG
int debuglevel=3;
#endif

entry e[MAX_ENTRIES];

/* ************************************* */
/*   Jiangang Guo's stuff */
/* ************************************* */

entry ev[30];

/* Figure out how gateway was invoked */
int requestMethod()
{
     char *rm;
#ifdef DEBUG
     if (debuglevel >= 1) {
	  (void) fprintf(stderr, "DEBUG: requestMethod() entered\n");
     }
#endif /* DEBUG */
     if ((rm=getenv("REQUEST_METHOD"))==(char*)NULL) return UNKNOWN;
     if (!strcmp(rm,"POST")) return POST;
     if (!strcmp(rm,"GET")) return GET;
     return UNKNOWN;
}

/* Debug setup */
#ifdef DEBUG
#ifdef __STDC__
void debugInit(int ac,char **av)
#else
void debugInit(ac,av)
     int ac;
     char **av;
#endif
{
     if (ac==2) {
	  if (!strcmp(av[1],"p")) {
	       fprintf(stderr,"DEBUG: wowstub()Debug override: POST method\n");
	       (void)putenv("ORACLE_SID=v7");
	       (void)putenv("ORACLE_HOME=/home/oracle7");
	       (void)putenv("REQUEST_METHOD=POST");
	       (void)putenv("CONTENT_LENGTH=11");
	       (void)putenv("PATH_INFO=/math.decimal2nbase");
	  } 
	  else if (!strcmp(av[1],"g")) {
	       fprintf(stderr,"DEBUG: wowstub()Debug override: GET method\n");
	       (void)putenv("ORACLE_SID=v7");
	       (void)putenv("ORACLE_HOME=/home/oracle7");
	       (void)putenv("REQUEST_METHOD=GET");
	       (void)putenv("QUERY_STRING=a=1234&b=22");
	       (void)putenv("PATH_INFO=/math.decimal2nbase");
	  }
     }
}
#endif

/* Panic and die */
#ifdef __STDC__
void wowFail(char *s)
#else
void wowFail(s)
     char *s;
#endif
{
#ifdef DEBUG
     if (debuglevel >= 1) {
	  (void) fprintf(stderr, "DEBUG: wowFail() entered\n");
     }
#endif /* DEBUG */
     printf("<title>WOW Error</title><h1>Wow Error</h1>\n%s\n",s);

#ifdef DEBUG
     if (debuglevel >= 1) {
	  (void) fprintf(stderr, "DEBUG: wowFail():%s\n",s);
     }
#endif /* DEBUG */

     exit(1);
}

/* Parse HTML input */
#ifdef __STDC__
int parseInput(int request)
#else
int parseInput(request)
     int request;
#endif
{
     int i,items=-1; /* kludge */
     int cl;                           /* content length */
     char *s,*qs;                      /* query string */

#ifdef DEBUG
     if (debuglevel >= 1) {
          (void) fprintf(stderr, "DEBUG: parseInput(request=%d) entered\n",request);
     }
#endif /* DEBUG */
     if (request == POST) {
          cl = atoi(getenv("CONTENT_LENGTH"));
         /* for(i=0;cl && (!feof(stdin));i++) {*/
          i = 0;
          while (cl && (!feof(stdin))) {
               e[i].val = fmakeword(stdin,'&',&cl);
               plustospace(e[i].val);
               unescape_url(e[i].val);
               e[i].name = makeword(e[i].val,'=');
               if ((i>0)&&(!strcmp(e[i].name,e[i-1].name)))
                 e[i-1].val = strcat(strcat(e[i-1].val,"&"),e[i].val);
               else {
                 items=i;
                 i++;
               }
          }
     }
     else if (request == GET) {
          s = getenv("QUERY_STRING");
          qs = (char*)malloc(strlen(s)+1);
          (void)strcpy(qs,s);
          /*for(i=0;qs[0] != '\0';i++) {*/
          i = 0;
          while (qs[0] != '\0') {
               e[i].val=(char*)malloc(MAXGETVAL); /* kludge */
               getword(e[i].val,qs,'&');
               plustospace(e[i].val);
               unescape_url(e[i].val);
               e[i].name=(char*)malloc(MAXGETNAME); /* kludge */
               getword(e[i].name,e[i].val,'=');
               if ((i>0)&&(!strcmp(e[i].name,e[i-1].name)))
                  e[i-1].val = strcat(strcat(e[i-1].val,"&"),e[i].val);
               else {
                 items=i;
                 i++;
               }
        }
     }
/* ************************************* */
/* Jiangang Guo's Stuff  */
/* ************************************* */
  ev[0].name="xREMOTE_ADDR";
  ev[0].val=getenv("REMOTE_ADDR");
/*
  ev[0].name="xAUTH_TYPE"; 
  ev[0].val=getenv("AUTH_TYPE"); 
  ev[1].name="xGATEWAY_INTERFACE";
  ev[1].val=getenv("GATEWAY_INTERFACE");
  ev[2].name="xHTTP_USER_AGENT";
  ev[2].val=getenv("HTTP_USER_AGENT");
  ev[3].name="xREMOTE_HOST";
  ev[3].val=getenv("REMOTE_HOST");
  ev[5].name="xREMOTE_USER";
  ev[5].val=getenv("REMOTE_USER");
  ev[6].name="xREMOTE_IDENT";
  ev[6].val=getenv("REMOTE_IDENT");
  ev[7].name="xSERVER_PROTOCOL";
  ev[7].val=getenv("SERVER_PROTOCOL");
  ev[8].name="xSERVER_SOFTWARE";
  ev[8].val=getenv("SERVER_SOFTWARE");
  ev[9].name="xSERVER_NAME";
  ev[9].val=getenv("SERVER_NAME");
  ev[10].name="xSERVER_PORT";
  ev[10].val=getenv("SERVER_PORT");
*/
     return items+1;
}

/* Build PL/SQL procedure to invoke user proc and retrieve result */
#ifdef __STDC__
char *plsqlBuild(char *gw,int items)
#else
char *plsqlBuild(gw,items)
     char *gw;
     int items;
#endif
{
     char *plsql;
     char c[8192];
     register i;

#ifdef DEBUG
     if (debuglevel >= 1) {
	  (void) fprintf(stderr, "DEBUG: plsqlBuild(gw=\"%s\",items=%d) entered\n",
			 gw,items);
     }
fprintf(stderr, "****: plsql");

#endif /* DEBUG */
     plsql=(char*)malloc(MAXPLSQL);

     (void)sprintf(plsql,"begin if :first=1 then OWA.init_cgi_env_wow("); 
    /* (void)strcat(plsql,c);*/
     (void)sprintf(c,"%s=>'%s');",ev[0].name,ev[0].val);
     (void)strcat(plsql,c);

     (void)sprintf(c,"%s%s",
		   gw,items ? "(" : ";end if;");

     (void)strcat(plsql,c);

     for(i=0;i<items;i++) {
	  (void)sprintf(c,"%s=>'%s'%s",e[i].name,e[i].val,
			i<items-1 ? "," : ");end if;" ); 
	  (void)strcat(plsql,c);
     }

     (void)strcat(plsql,"wow.get_page(:lines,:nlines);end;"); 

/*     printf(plsql);*/

     return plsql;
}

/* Oracle interface */
#ifdef __STDC__
void runOra(char *uid,char *plsql)
#else
void runOra(uid,plsql)
     char *uid;
     char *plsql;
#endif
{
     dbConnection *db;
     Cda_Def *cda;
     text lines[ARRSZ][255];
     sb2 ilines[ARRSZ];
     ub2 rlines[ARRSZ];
     ub2 llines[ARRSZ];
     ub4 retarr;
     int nlines;
     sb2 inlines;
     int first;
     sb2 ifirst;
     int i;

     if ((db=(dbConnection*)malloc(sizeof(dbConnection)))==NULL)
       wowFail("runOra() malloc() failed!");

/*     uid="richard/richard\0";
     printf("UID= %s plsql=%s\n",uid,plsql);
*/
     dbLogon(db,uid);

     cda=dbParse(db->lda,plsql);
     dbBindArr(db->lda,cda,":lines",(ub4)ARRSZ,lines,(ub2*)llines,
	       (sb2*)ilines,(ub2*)rlines,&retarr);
     dbBindNum(db->lda,cda,":nlines",&nlines,&inlines);
     dbBindNum(db->lda,cda,":first",&first,&ifirst);
 
    for (nlines=ARRSZ,first=1;nlines==ARRSZ;first=0) {
	  for (i=0;i<ARRSZ;i++) {
	       *(lines[i])='\0';
	       llines[i]=0;
	  }
	   /*fprintf(stderr,"before 4th  aaUID= %s\n",uid);*/
	  dbExe(db->lda,cda);
	     /*fprintf(stderr,"4th  aaUID= %s\n",uid); */  
	  for (i=0;i<nlines;i++) {
	       lines[i][(int)llines[i]]='\0';
	       printf("%s\n",lines[i]);
	  }
     }
     dbClose(db->lda,cda);
     dbFinish(db->lda);
}

/* Main gateway stub */
#ifdef __STDC__
main(int ac,char **av)
#else
main(ac,av)
     int ac;
     char **av;
#endif
{
     char *gw, *uid, *plsql;
     int items=0;
     int request;
     register i;

#ifdef DEBUG
     if (debuglevel >= 1)
       (void) fprintf(stderr, "DEBUG: wowstub() entered.\n");
     debugInit(ac,av);
#endif /* DEBUG */

     printf("Content-type: text/html\n\n");

     if ((uid=getenv("WOW_UID"))==(char*)NULL) {
	  uid=(char*)malloc(strlen(WOW_UID)+1);
	  strcpy(uid,WOW_UID);
     }

     if ((gw=getenv("PATH_INFO"))==(char*)NULL) 
       wowFail("PATH_INFO not set!");

     gw=&(gw[1]);

/*     printf("BEFORE requestMethod");   */ 
     request=requestMethod();
/*      printf("BEFORE parseInput");  */  
     items=parseInput(request);
/*      printf("BEFORE plsqlBuild");  */  
     plsql=plsqlBuild(gw,items);

#ifdef DEBUG
     if (debuglevel >= 2) {
	  (void)fprintf(stderr,"wowstub():\nuid=%s\ngw=%s\nplsql=%s\n",
			uid,gw,plsql);
	  (void)fprintf(stderr, "parameters:\n");
	  for (i=0;i<items;i++) {
	       fprintf(stderr,"\tname[%d]=%s val[%d]=%s\n",
		       i,e[i].name,i,e[i].val);
	  }
     }
#endif /* DEBUG */
/*     printf("BEFORE RUNORA: %s",plsql);   */
/*     printf("ev[0].name=%s",ev[0].name);  */
/*     printf("ev[0].val=%s",ev[0].val);    */
 
     runOra(uid,plsql); 
     exit(0);
}
	 
